/* By Thorbjorn Jemander, thorbjorn.jemander@swipnet.se */

#include <stdio.h>

#define min(x,y) ((x)<(y)?(x):(y))

int
main( int argc, char *argv[] )
{
	FILE 	*file1,
			*file2;

	unsigned char 	*Buffer1,
			*Buffer2,
		 	*FileName1,
			*FileName2;
	int 	i,
			File1Size,
			File2Size;

	if( argc < 3 )
	{
		printf("Need two files.\n");
		return 10;
	}

	FileName1 = argv[1];
	FileName2 = argv[2];

	file1 = fopen( FileName1,"rb" );

	if( ! file1 )
	{
		printf("Can't open file '%s'\n", FileName1 );
		return 10;
	}

	file2 = fopen( FileName2,"rb" );

	if( ! file2 )
	{
		printf("Can't open file '%s'\n", FileName2 );
		fclose( file1 );
		return 10;
	}

	fseek( file1, 0L, SEEK_END );
	File1Size = ftell( file1 ) + 1;
	rewind( file1 );

	fseek( file2, 0L, SEEK_END );
	File2Size = ftell( file2 ) + 1;
	rewind( file2 );

	Buffer1 = (char*)malloc( File1Size ); 

	if( ! Buffer1 )
	{
		printf("Can't allocate a %d byte buffer for file 1.\n", File1Size );
		fclose( file2  );
		fclose( file1 );
		return 10;
	}


	Buffer2 = (char*)malloc( File2Size ); 

	if( ! Buffer2 )
	{
		printf("Can't allocate a %d byte buffer for file 2.\n", File2Size );
		free( Buffer1 );
		fclose( file2  );
		fclose( file1 );
		return 10;
	}

	fread( Buffer1, File1Size, 1, file1 );
	fread( Buffer2, File2Size, 1, file2 );

	printf("Length of file '%s': %d\n", FileName1, File1Size );
	printf("Length of file '%s': %d\n", FileName2, File2Size );

	printf("File '%s' differs from '%s' in the following positions:\n", FileName1, FileName2);
	printf("Position '%s' '%s'\n", FileName1, FileName2 );

	for( i=0; i<min(File1Size,File2Size); i++ )
		if( Buffer1[i] != Buffer2[i] )
			printf("  %05d  %2d  %2d\n", i, Buffer1[i], Buffer2[i] );

	printf("Ready.\n");
	
	free( Buffer1 );
	free( Buffer2 );

	fclose( file1 );
	fclose( file2 );

}